Program Zh12_13_2_2_2;
{
 Szerz: Szlvi Pter
 Neptun-kd: ZDOF7J

 Feladat (2012/13 2. flv 2. zh. 2. feladat):
 Adott egy egszekbl ll als hromszg mtrix (vagyis a f diagonlis 
 felett csupa 0 ll). Keressen meg egy olyan oszlopot, amelyre igaz, hogy 
 elemei sszegnek abszolt rtkt mod 2 vve 0-t kapunk, a mgtte lev
 oszlop elemei sszegnek abszolt rtkt mod 2 vve pedig 1-t kapunk, 
 vagy fordtva (az els ad 1-t, a mgtte lv pedig 0-t)! 
 
 Eljrs Lass_Keress(N:Egsz, X:Tmbtip, Vltoz Van:Logikai, Hol:Egsz):
   Van:=Hamis
   Ciklus j=1-tl N-1-ig
     Ha ((((Oszloposszeg(j) mod 2)=0) s ((Oszloposszeg(j+1) mod 2)=1)) vagy
	    (((Oszloposszeg(j) mod 2)=1) s ((Oszloposszeg(j+1) mod 2)=0))) s nem Van
	 akkor Van:=Igaz; Hol:=j
     Elgazs vge
   Ciklus vge
 Eljrs vge.

 Fggvny Oszloposszeg(j):egsz
   s:=0
   Ciklus i=1-tl N-ig
     s:=s+X[i,j]
   Ciklus vge
   Ha s>=0 akkor Oszloposszeg:=s klnben Oszloposszeg:=(-1)*s
 Fggvny vge
 
 rja t a fenti eljrst idben hatkonyabbra! rja meg az idben 
 hatkonyabb Pascal programot!
   
 Megolds algoritmusa:
 
 Eljrs Gyors_Keress(N:Egsz, X:Tmbtip, Vltoz Van:Logikai, Hol:Egsz):
   j:=1
   oA0:=Oszloposszeg(1) mod 2=0 //az aktulis oszlop sszege pros-e?
   oK0:=Oszloposszeg(2) mod 2=0 //a kvetkez oszlop sszege pros-e?
   Ciklus amg j<N s (nem oA0 vagy oK0) s (oA0 vagy nem oK0)
     j:+1
     oA0:=oK0
     oK0:=Oszloposszeg(j+1) mod 2=0
   Ciklus vge
   Van:=j<N
   Ha Van akkor Hol:=j
 Eljrs vge.

 Fggvny Oszloposszeg(j):egsz
   s:=0
   Ciklus i=j-tl N-ig
     s:+X[i,j]
   Ciklus vge
   Oszloposszeg:=s
 Fggvny vge
  
}
  Uses
    Crt;
  Const
    MaxN=20;
  Type
    TombTip=Array [1..MaxN,1..MaxN] of Integer;
  Var
    AHM:TombTip;
    N:Integer;
    VanE:Boolean;
    Hol:Integer;

  Procedure Feltolt;
    var
      i,j:Integer;
      c:Char;
  Begin
    Write('A mret:'); Readln(N);
    Writeln('Kalviatura-bemenet/Automatikusan? (K/A)');
    c:=ReadKey;
    If UpCase(c)='K' then
    Begin
      For i:=1 to N do
      Begin
        For j:=1 to i do
        Begin
          Write('(',i:3,',',j:3,'):'); Readln(AHM[i,j]);
        End;
        For j:=j+1 to N do
        Begin
          AHM[i,j]:=0;
        End;
      End;
    End
      else
    Begin
      For i:=1 to N do
      Begin
        For j:=1 to i do
        Begin
          AHM[i,j]:=Random(2*N)-N;
        End;
        For j:=j+1 to N do
        Begin
          AHM[i,j]:=0;
        End;
      End;
    End;
    //ellenrz listzs:
    For i:=1 to N do
    Begin
      For j:=1 to N do
      Begin
        Write(AHM[i,j]:3);
      End;
      Writeln;
    End;
  End;

  //a hatkonysg mrs kedvrt szmlljuk a jellegzetes mveleteket:
  
  Var
    hozzaDb:Integer;
  
  Procedure Inic;
  Begin
    hozzaDb:=0;
  End;

  Procedure Hozzaad(Var s:Integer; Const e:Integer);
  Begin
    s:=s+e;
    Inc(hozzaDb);
  End;
  
//Eredeti kd: ---------------------------------------------------------
  
  Procedure Lassu_Kereses(N:Integer; X:TombTip; Var Van:Boolean; Var Hol:Integer);
    Var
      j:Integer;
      
    Function Oszloposszeg(Const j:Integer):Integer;
      Var
        s,i:Integer;
    Begin
      s:=0;
      For i:=1 to N do
      Begin
//        s:=s+X[i,j];
        Hozzaad(s,X[i,j]);
      End;
      If s>=0 then Oszloposszeg:=s else Oszloposszeg:=(-1)*s;
    End;
    
  Begin
    Van:=False;
    For j:=1 to N-1 do
    Begin
      If
        ((((Oszloposszeg(j) mod 2)=0) and ((Oszloposszeg(j+1) mod 2)=1)) or
	    (((Oszloposszeg(j) mod 2)=1) and ((Oszloposszeg(j+1) mod 2)=0))) and
	    not Van then
	  Begin
	    Van:=True; Hol:=j;
	  End;
    End;
  End;

//Hatkonyabb kd: -----------------------------------------------------
  
  Procedure Gyors_Kereses(N:Integer; X:TombTip; Var Van:Boolean; Var Hol:Integer);
    Var
      j:Integer;
      oOA0,oOK0:Boolean;
      
    Function Oszloposszeg(Const j:Integer):Integer;
      Var
        s,i:Integer;
    Begin
      s:=0;
      For i:=j to N do
      Begin
//        s:=s+X[i,j];
        Hozzaad(s,X[i,j]);
      End;
      Oszloposszeg:=s;
    End;
    
  Begin
    j:=1;
    oOA0:=Oszloposszeg(1) mod 2=0;//az aktulis oszlop sszege pros-e?
    oOK0:=Oszloposszeg(2) mod 2=0;//a kvetkez oszlop sszege pros-e?
    While  (j<N) and (not oOA0 or oOK0) and (oOA0 or not oOK0) do
    Begin
      Inc(j);
      oOA0:=oOK0;
      oOK0:=Oszloposszeg(j+1) mod 2=0;
    End;
    Van:=j<N;
    If Van then Hol:=j;
  End;
   
Begin
  ClrScr;
  Feltolt;
  
  Inic;
  Lassu_Kereses(N,AHM,VanE,Hol);
  If VanE then
  Begin
   Writeln('Van, mgpedig a(z) ',Hol,'. oszlopnl.');
  End 
    else
  Begin
   Writeln('Nincs.');
  End;
  Writeln('sszeadsok szma:',hozzaDb);

  Inic;
  Gyors_Kereses(N,AHM,VanE,Hol);
  If VanE then
  Begin
   Writeln('Van, mgpedig a(z) ',Hol,'. oszlopnl.');
  End 
    else
  Begin
   Writeln('Nincs.');
  End;
  Writeln('sszeadsok szma:',hozzaDb);
  ReadKey;
End.
